Your agent says it refunded $42.50. Prove it.
Every consequential action gets a signed, hash-chained receipt. Anchor the chain with a timestamp from an authority you don’t control, and anyone can verify the record offline, without trusting you.
Open source (MIT). Packages are not on npm yet: run from source.
Exhibit A: live chain
SHA-256 computed in your browser- SEQ 0refund.issue$42.50linkedprev null → self d504ed98…8ec6cf3f
- SEQ 1email.sendno amountlinkedprev d504ed98…8ec6cf3f → self 98536b38…76e00bf1
- SEQ 2refund.issue$180.00linkedprev 98536b38…76e00bf1 → self 55f1f1fd…3fdaeb3b
- ANCHORDigiCert, Inc. · RFC 3161 · 2026-10-27matchescommitted head 55f1f1fd…3fdaeb3b
The anchor row compares the recomputed head with the head that was timestamped. The timestamp token and the agent’s public key are not on this page, so the anchor and the signatures can’t be checked here. To check a DigiCert anchor yourself, verify the sample bundle in the repository, a separate three-receipt chain, with the offline verifier: Verify a bundle.
Built on open standards
- RFC 8785
- SHA-256
- Ed25519
- RFC 9421
- RFC 3161
MIT-licensed core and verifier · Source on GitHub
Signed, hash-chained receipts
Each receipt is canonicalized with RFC 8785, chained with SHA-256 and signed with Ed25519, so altering or removing one breaks the chain at that receipt.
RFC 3161 anchoring
When you anchor (with an evidence bundle), the chain head is timestamped by an RFC 3161 timestamp authority the operator does not control, so the record up to that point cannot be quietly rewritten or backdated.
Free offline verifier
The verifier is MIT-licensed, needs no network and no account, and lets anyone check an evidence bundle on their own machine.
Once anchored, history up to the anchor can’t be rewritten: not by your agents, and not by you.
Before an anchor, a chain is self-attested: it proves internal consistency, not that history was left alone. The table shows exactly where the line falls.
| Property | Local chain | Anchored chain |
|---|---|---|
| Detects casual tampering | yes | yes |
| Detects a full rebuild of anchored history by the operator | no | yes |
| Detects a rebuild made before that history was anchored | no | no |
| Detects backdating after the anchor | no | yes |
| Detects truncation of the un-anchored tail | no | no |
What you can get today
Lacre Core: free. Record, chain and verify receipts on your own machine, and check evidence bundles with the offline verifier. MIT-licensed. Run it from source: the packages are not on npm yet.
Evidence bundle: bundles open soon. Checkout is not open yet, so nothing can be bought or charged here today. The planned price is $15 each. How a bundle will be made, or tell me when bundles open.
Cloud: early access. Continuous anchoring is planned, not available yet. Join the waitlist.